      *
      * @(#)smstart.cbl	1.4
      ****************************************************************
      * Copyright Micro Focus Limited 1989-92. All Rights Reserved.  *
      * This demonstration program is provided for use by users of   *
      * Micro Focus products and may be used, modified and           *
      * distributed as part of your application provided that you    *
      * properly acknowledge the copyright of Micro Focus in this    *
      * material.                                                    *
      ****************************************************************
      * This program initialises the shared memory and semaphore required
      * by sharemem.cbl. Please see sharemem.cbl for full details.

      $ set vsc2 rtncode-size(4)
	copy "smwrks.cpy".

        procedure division.
        main section.
      *
      * Set up the main synchronization semaphore
      *
	    perform cbl-semget

      **************************************************
      * The last parameter to the semctl call below is defined by Unix  
      * systems as a Union. Some C compilers require unions to 
      * be passed by value whilst others require them to be passed
      * as a pointer, ie by reference. There are two versions of the
      * relevant call statement below the first passes the final parameter
      * by value, whilst the second passes it by reference. This system
      * requires the parameter to be passed by value so the other version
      * of the call has been commented out.
      **************************************************

      * Pass final parameter by value
                             call "semctl" using by value
                                   cbl-semid zeroarg setval onearg

      * Pass final parameter by reference
      *     call "semctl" using by value
      *                         cbl-semid zeroarg setval 
      *                         by reference onearg
       

      * Set up and initialize shared memory
      *
	    perform cbl-memget
	    move zeros to counter
	    stop run.
      *
      * Generic routines
      *
	copy "smproc.cpy".
