      $set mfoo linkcount(255)
      *>----------------------------------------------------------------
      *> The persistenceManager handles the saving and loading of
      *> persistent objects.
      *>
      *> Copyright (c) Micro Focus Ltd 1991, 1996
      *>
      *>----------------------------------------------------------------

       class-id. persistencemanager is abstract data is protected.

       select out-file assign to DYNPRT
           organization is line sequential.

       object section.
       class-control.
           persistencemanager is class "persist".
       file section.
       fd out-file.
       01 out-rec pic x(280).
       working-storage section.

       01 dynprt pic x(80).
       01 dbcsEnvironmentStatus    pic x comp-5 external.
           88  isSBCSEnv value 1.
           88  isDBCSEnv value 2.

       78 objectreferenceSize value 4.
       01 ExceptionManager usage object reference.
       01 persistentstoreerror pic x(4) comp-5.
       01 anerrmessage         usage object reference.
       01 sessionstatus pic 9 comp-5.
           88 notfirstsession  value 0.
           88 firstsession     value 1.
       01 display-status-key pic zz9.
       01 afcd.
           05  fcd-file-status.
               10  fcd-status-key-1 pic x.
                   88 noobjstorefileerror value "0".
               10  fcd-status-key-2 pic x.
               10  fcd-binary redefines fcd-status-key-2
                                    pic 99 comp-x.
           05  filler               pic x(3).
           05  fcd-organization     pic 9(2) comp-x.
           05  fcd-access-mode      pic 9(2) comp-x.
           05  fcd-open-mode        pic 9(2) comp-x.
           05  filler               pic x(3).
           05  fcd-name-length      pic 9(4) comp-x.
           05  filler               pic x(11).
           05  fcd-lock-mode        pic 9(2) comp-x.
           05  fcd-other-flags      pic 9(2) comp-x.
           05  filler               pic x(2).
           05  fcd-handle           usage pointer.
           05  filler               pic x.
           05  fcd-status-type      pic 9(2) comp-x.
           05  fcd-file-format      pic 9(2) comp-x.
           05  filler               pic x(3).
           05  fcd-max-rec-length   pic 9(4) comp-x.
           05  filler               pic x(3).
           05  fcd-relative-key     pic 9(9) comp-x.
           05  fcd-recording-mode   pic 9(2) comp-x.
           05  fcd-current-rec-len  pic 9(4) comp-x.
           05  fcd-min-rec-length   pic 9(4) comp-x.
           05  fcd-key-id           pic 9(4) comp-x.
           05  fcd-line-count       redefines fcd-key-id
                                    pic 9(4) comp-x.
           05  fcd-key-length       pic 9(4) comp-x.
           05  fcd-record-address   usage pointer.
           05  fcd-filename-address usage pointer.
           05  fcd-key-def-address  usage pointer.
           05  filler               pic x(10).
           05  fcd-data-compress    pic 9(2) comp-x.
           05  filler               pic x(21).

       01  afhfunction.
           03  filler         pic x value x"fa".
           03  extfh-op-code  pic x.

       01 thekeydefinitionarea.
      *>>
      *>> Global Information Area. 14 bytes in length.
      *>>
           05 global-information-area.
              10 length-of-key-def-area   pic 9(4)  comp-x.
              10 filler                   pic x(4).
              10 number-of-keys           pic 9(4)  comp-x.
              10 filler                   pic x(6).
      *>>
      *>> Key Definition Parameter Block Area.
      *>>
           05  key-definition-parameter-block.
               10 component-count     pic 9(4) comp-x.
               10 offset-to-component pic 9(4) comp-x.
               10 key-flags           pic 9(2) comp-x.
               10 key-compression     pic 9(2) comp-x.
               10 sparse-character    pic x.
               10 filler              pic x(9).
      *>>
      *>> Component Definition Area.
      *>>
           05  component-definition-area.
               10 filler                  pic x(2).
               10 offset-to-component-def pic 9(9) comp-x.
               10 component-length  pic 9(9) comp-x.

       78 fhindexed value 2.
       78 fhvariable value 1.
       78 fhrandomaccess value 4.
       78 fhautomaticlocking value 1.
       78 fhotherflags value 0.
       78 fhansi85 value 1.
       78 fhdefaultfileformat value 0.
      *>>78 fhmaxrecordlength value 1024.
       78 fhmaxrecordlength value 63488.
       78 fhminrecordlength value 4.
       78 fhprimarykeyidentifier value  0.
       78 fhdelete        value x"F7".
       78 fhopenio       value x"02".
       78 fhclose          value x"80".
       78 fhread           value x'D8'.
       78 fhstartEqual     value x'E8'.
       78 fhwrite          value x"F3".
       78 fhrewrite        value x"F4".
       78 fhprimekeydef value  16.
       01 fhDuplicatesAllowed pic x comp-5 value 64.

       01 objectsFinalizedPtr usage pointer.
       01 objectsFinalizedHeapTop pic x(4) comp-5 value 0.
       01 objectsFinalizedBufferSize pic x(4) comp-5 value 65528.
      *>> Maximum number of object references which may be buffered
      *>> is 65528/4 = 16,190 references
       01 memAllocFlags pic x comp-5 value 0.
       01 recordBufferPtr  usage pointer.
       01 maxRecordBufferLength pic x(4) comp-5.
       78 objectKeyLength value 4.
       01 filedetails.
           03 file-size     pic x(8) comp-x.
           03 file-date     pic x(4) comp-x value zero.
           03 file-time     pic x(4) comp-x.

       01 oodirsplitjoinparams.
           05 paramlength          pic xx comp-x.
           05 splitjoinflag1       pic x comp-x value 0.
           05 splitjoinflag2       pic x comp-x value 0.
           05 pathoffset           pic xx comp-x value 1.
           05 pathlength           pic xx comp-x value 0.
           05 basenameoffset       pic xx comp-x value 1.
           05 basenamelength       pic xx comp-x value 0.
           05 oodirextensionoffset pic xx comp-x value 1.
           05 extensionlength      pic xx comp-x value 0.
           05 oodirtotallength     pic xx comp-x value 0.
           05 splitbuflength       pic xx comp-x value 65.
           05 joinbuflength        pic xx comp-x value 65.
           05 firstpathcomponentlength pic xx comp-x value 0.

       01 basenamePtr              usage pointer.
       01 pathnamePtr              usage pointer.

       01 splitjoinparams.
           05 paramlength          pic xx comp-x.
           05 splitjoinflag1       pic x comp-x value 0.
           05 splitjoinflag2       pic x comp-x value 0.
           05 pathoffset           pic xx comp-x value 1.
           05 pathlength           pic xx comp-x value 0.
           05 basenameoffset       pic xx comp-x value 1.
           05 basenamelength       pic xx comp-x value 0.
           05 extensionoffset      pic xx comp-x value 1.
           05 extensionlength      pic xx comp-x value 0.
           05 totallength          pic xx comp-x value 0.
           05 splitbuflength       pic xx comp-x value 65.
           05 joinbuflength        pic xx comp-x value 65.
           05 firstpathcomponentlength pic xx comp-x value 0.

       01 splitjoin-storage-vars.
          03 StoredOffset          pic xx comp-x.
          03 StoredExtOffset       pic xx comp-x.
          03 filler-1.
             05 StoredLength       pic xx comp-x.
             05 StoredPathLength   pic xx comp-x.
          03 BackupExtension redefines filler-1.
             05 BackupExtensionBase  pic xx.
             05 BackupExtensionNo    pic 9(2) comp-x.

       78 78-DefaultDataFileExtn   value "dat".
       78 78-DefaultIndexFileExtn  value "idx".
       78 78-unixIndexFileExtn     value ".idx".
       78 78-DefaultBackupDATExt   value "dt".
       78 78-DefaultBackupIDXExt   value "ix".

       78 maxfilenamelength        value 255.
       01 anobjstorefilename       pic x(maxfilenamelength).

       01 theoodirenvvarname  pic x(5) value "OODIR".
       01 theoodirenvvarvalue pic x(65) value spaces.
       01 thebackupfilename   pic x(maxfilenamelength).
       01 thebackupfilename2  pic x(maxfilenamelength).

       object-storage section.


       procedure division.
           invoke self "initializeclass".
           exit program.

      *>----------------------------------------------------------------
      *> PRIVATE. initialize class data
      *>----------------------------------------------------------------
       method-id. "initializeclass".
       procedure division.
           set fcd-filename-address to null
           set objectsFinalizedPtr to null
           exit method.
       end method "initializeclass".

      *>-----------------------------------------------------------------
      *> PRIVATE. This method is invoked (by the OOPS) at the start of
      *> every session. It determines whether this is the very first
      *> session or whether it needs to restore external data items.
      *> The handles for the classses are included within the external
      *> data items.
      *>-----------------------------------------------------------------

       method-id. "atStartOfSession".

      *>> The existence of a data file (holding object's data)
      *>> indicates that the environment needs to be restored
       linkage section.
       01 objstorefilename     pic x(maxfilenamelength).
       procedure division using objstorefilename.
               perform deriveobjstorefilename
               move low-values to filedetails
               call "CBL_CHECK_FILE_EXIST"
                    using anobjstorefilename
                          filedetails
               if file-date = zero
                   set firstsession to true
               else
                   set notfirstsession to true
               end-if
           exit method.


       deriveobjstorefilename section.

      *>> anObjStoreFilename consists of a path and filename.
      *>> The objStoreFilename is the application program name and its
      *>> path. Alternatively the path and/or filename details maybe
      *>> supplied in the environment varible OODIR
      *>>
      *>> Priority list of various path and filename combinations:
      *>>    1) path and filename supplied in OODIR
      *>>    2) path in objStoreFilename, filename in OODIR
      *>>    3) filename in objStoreFilename, pathname in OODIR
      *>>    4) path and filename in objStoreFilename

           move space to theoodirenvvarvalue
           display theoodirenvvarname upon environment-name
           accept theoodirenvvarvalue from environment-value

           move spaces to anObjstoreFilename
           move length of splitjoinparams to
                   paramlength of splitjoinparams
                   paramlength of oodirsplitjoinparams
           call "CBL_SPLIT_FILENAME" using
                           oodirsplitjoinparams
                           theoodirenvvarvalue
           call "CBL_SPLIT_FILENAME" using
                           splitjoinparams
                           objstorefilename
           if pathlength of oodirsplitjoinparams = 0
      *        no path specified in oodir -
      *        use program's path (if there is one)
               set pathnamePtr to address of objstorefilename
           else
      *        oodir does contain a path - so use that
               set pathnamePtr to address of theoodirenvvarvalue
      *        set up path length and offset params
               move pathlength of oodirsplitjoinparams
                   to pathlength of splitjoinparams
               move pathoffset of oodirsplitjoinparams
                   to pathoffset of splitjoinparams
           end-if
           if basenamelength of oodirsplitjoinparams = 0
            *>> No filename supplied in OODIR
      *        use program's basename (there is always one)
               set basenamePtr to address of objstorefilename
           else
            *>> basename is available from OODIR
               set basenamePtr to address of theoodirenvvarvalue
      *        set up basename length and offset params
               move basenamelength of oodirsplitjoinparams
                   to basenamelength of splitjoinparams
               move basenameoffset of oodirsplitjoinparams
                   to basenameoffset of splitjoinparams
           end-if.

      * now lnkpath and lnkbase point to either
      * objstorefilename or theoodirenvvarvalue depending on
      * whether theoodirenvvarvalue contains either path or
      * basename (or both). the path/basename offsets and lengths
      * in splitjoinparams will have been set up accordingly

      * set up extension offset and length for .dat extension
           move 1 to extensionoffset of splitjoinparams
           move 3 to extensionlength of splitjoinparams
           call "CBL_JOIN_FILENAME" using
                           splitjoinparams
                           anobjstorefilename  *> result buffer
                  by value pathnameptr         *> path buffer
                  by value basenameptr         *> basename buffer
               by reference 78-DefaultDataFileExtn *> extension
           *> debug - remove later
           *> display anobjstorefilename

       end method "atStartOfsession".

      *>-----------------------------------------------------------------
      *> PRIVATE. Writes an objects details to the persistent store
      *>-----------------------------------------------------------------

       method-id. "write".
       working-storage section.
       01 objectSize pic x(4) comp-5.
       01 aPtr usage pointer.
       01 moveLength pic x(4) comp-5.
       01 objectRecordPtr  usage pointer.
       linkage section.
       01 objectRecord pic x.
       01 recordBuffer.
           03 objectkey      usage object reference.
       01 objdetails.
           03 objhandle    usage object reference.
           03 objsize      pic x(4) comp-5.
           03 objaddress   pointer.
       procedure division using objdetails.
           if fcd-filename-address = null
               invoke self "openFile"
           end-if
           move objSize to objectSize
           set objectRecordPtr to objAddress
           set aPtr to recordBufferPtr
           set fcd-record-address to aPtr
           set address of recordBuffer to aPtr
           set objectkey to objhandle

           move fhStartEqual to extfh-op-code
           call "EXTFH" using afhfunction, afcd
           perform until not noObjStorefileError
               move fhDelete to extfh-op-code
               call "EXTFH" using afhfunction, afcd
               move fhStartEqual to extfh-op-code
               call "EXTFH" using afhfunction, afcd
           end-perform

           perform until objectSize = 0
               if objectSize < maxRecordBufferLength
                   move objectSize to moveLength
                   move 0 to objectSize
               else
                   subtract maxRecordBufferLength from objectSize
                   move maxRecordBufferLength to moveLength
               end-if
               set address of objectRecord to objectRecordPtr

               set aPtr to recordBufferPtr
               set aPtr up by length of objHandle
               set address of recordBuffer to aPtr
               move objectRecord(1:moveLength)
                           to recordBuffer(1:moveLength)

               move moveLength to fcd-current-rec-len
               add length of objHandle to fcd-current-rec-len
               move fhwrite to extfh-op-code
               call "EXTFH" using afhfunction, afcd
               if not noobjstorefileerror
                   display "fail"
               end-if
               set objectRecordPtr up by moveLength
           end-perform
           exit method.
           end method "Write".

      *>-----------------------------------------------------------------
      *> Backs up the persistence file after renaming the
      *> previous backup files (.DTn & .IXn)
      *>-----------------------------------------------------------------

       method-id. "BackupPersistenceFile".
       working-storage section.
       01 CBL-Status   PIC XX COMP-5.
       local-storage section.
       01 sessionStatus    pic x comp-5.
           88  isFirstSession  value 1.
           88  isNotFirstSession  value 0.
       01 idxextensionoffset pic x comp-5.
       01  OS-Info-Param-Block.
           03  Parameter-Size         PIC X(2) COMP-X.
           03  P-OS-Type              PIC X COMP-X.
               78 78-Unix             value 128.
           03  FILLER                 PIC X(12).
       
       procedure division.
           move 13 to Parameter-Size
           call "CBL_GET_OS_INFO" using OS-Info-Param-Block
           invoke self "isFirstSession"
                   returning sessionStatus
           if isNotFirstSession
               invoke self "atEndOfSession"
               move anObjstoreFilename to thebackupfilename
               move anObjstoreFilename to thebackupfilename2
               call "CBL_SPLIT_FILENAME" using splitjoinparams
                                           anObjstoreFilename
               move extensionoffset to StoredOffset
               move 78-DefaultBackupDATExt to BackupExtensionBase
               move 57 to BackupExtensionNo
               move BackupExtension
                       to thebackupfilename ( extensionOffset:3 )
               call "CBL_DELETE_FILE" using thebackupfilename
                   returning cbl-status
               if cbl-status = 0 then
                   perform idx-name1
                   call "CBL_DELETE_FILE" using thebackupfilename
                       returning cbl-status
                   perform clear-idx
               end-if
               perform until BackupExtensionNo = 48
                   move 78-DefaultBackupDATExt to BackupExtensionBase
                   move BackupExtension
                           to thebackupfilename2 ( extensionOffset:3 )
                   subtract 1 from BackupExtensionNo
                   move BackupExtension
                           to thebackupfilename ( extensionOffset:3 )
                   call "CBL_RENAME_FILE" USING thebackupfilename
                                            thebackupfilename2
                      returning cbl-status
                   if  cbl-status = 0
                       perform idx-name1
                       perform idx-name2
                       call "CBL_RENAME_FILE" USING thebackupfilename
                                                  thebackupfilename2
                            returning cbl-status
                       perform clear-idx
                   end-if
               end-perform
               move 78-DefaultBackupDATExt
                    to thebackupfilename ( extensionOffset:2 )
               call "CBL_COPY_FILE" USING anobjstorefilename
                                      thebackupfilename
                   returning cbl-status
               if cbl-status = 0
                   move anObjstoreFilename to thebackupfilename2
                   perform idx-name1
                   if P-OS-Type = 78-unix then
                       add 1 to totallength giving idxextensionoffset
                       move 78-unixIndexFileExtn
                           to thebackupfilename2 (idxextensionOffset:4 )
                   else
                       move 78-DefaultIndexFileExtn
                           to thebackupfilename2 ( extensionOffset:3 )
                   end-if
                   call "CBL_COPY_FILE" USING thebackupfilename2
                                               thebackupfilename
                        returning cbl-status
                   perform clear-idx
               end-if
               if  cbl-status not = 0
                     move 90 to persistentstoreerror
                     invoke self "raiseexception"
                               using persistentstoreerror
               end-if
           end-if
           exit method.
       idx-name1 section.
           if P-OS-Type = 78-unix then
               add 1 to totallength giving idxextensionoffset
               move 78-unixIndexFileExtn
                           to thebackupfilename (idxextensionOffset:4 )
           else
               move 78-DefaultBackupIDXExt
                           to thebackupfilename ( extensionOffset:2 )
           end-if
           .
       idx-name2 section.
           if P-OS-Type = 78-unix then
               add 1 to totallength giving idxextensionoffset
               move 78-unixIndexFileExtn
                           to thebackupfilename2 (idxextensionOffset:4 )
           else
               move 78-DefaultBackupIDXExt
                           to thebackupfilename2 ( extensionOffset:2 )
           end-if
           .
       clear-idx section.
           if P-OS-Type = 78-unix then
               move spaces
                       to thebackupfilename (idxextensionOffset:4 )
               move spaces
                       to thebackupfilename2 (idxextensionOffset:4 )
           end-if.
       end method "BackupPersistenceFile".
      *>-----------------------------------------------------------------
      *> PRIVATE. Deletes all backups of the persistence file (*.DTn
      *>  & *.IXn)
      *>-----------------------------------------------------------------

       method-id. "EraseAllPersistenceBackupFiles".
       working-storage section.
       01 CBL-Status PIC XX COMP-5.
       local-storage section.
       01 idxextensionoffset pic x comp-5.
       01  OS-Info-Param-Block.
           03  Parameter-Size         PIC X(2) COMP-X.
           03  P-OS-Type              PIC X COMP-X.
               78 78-Unix             value 128.
           03  FILLER                 PIC X(12).
       procedure division.
           move 13 to Parameter-Size
           call "CBL_GET_OS_INFO" using OS-Info-Param-Block
           move anObjstoreFilename to thebackupfilename
           call "CBL_SPLIT_FILENAME" using splitjoinparams
                                           anObjstoreFilename
           move 78-DefaultBackupDATExt to BackupExtensionBase
           move 58 to BackupExtensionNo
           perform until BackupExtensionNo = 48
               subtract 1 from BackupExtensionNo
               move BackupExtension
                           to thebackupfilename ( extensionOffset:3 )
               call "CBL_DELETE_FILE" using thebackupfilename
                       returning cbl-status
               if cbl-status = 0
                   move thebackupfilename to thebackupfilename2
                   if P-OS-Type = 78-unix then
                       add 1 to totallength
                                       giving idxextensionoffset
                       move 78-unixIndexFileExtn
                           to thebackupfilename2 (idxextensionOffset:4 )
                   else
                       move 78-DefaultBackupIDXExt
                           to thebackupfilename2 ( extensionOffset:2 )
                   end-if
                   call "CBL_DELETE_FILE" using thebackupfilename2
                            returning cbl-status
               end-if
           end-perform
           exit method
       end method "EraseAllPersistenceBackupFiles".
      *>-----------------------------------------------------------------
      *> PRIVATE. Reads an objects details from the persistent store
      *>-----------------------------------------------------------------

       method-id. "read".
       working-storage section.
       01 aPtr usage pointer.
       01 objectSize pic x(4) comp-5.
       01 movelength pic x(4) comp-5.
       01 objectRecordPtr usage pointer.
       linkage section.
       01 objectrecord pic x.
       01 recordBuffer.
           03 objectkey      usage object reference.
       01 objdetails.
           03 objhandle    usage object reference.
           03 objsize      pic x(4) comp-5.
           03 objaddress   pointer.

       procedure division using objdetails.
           if fcd-filename-address = null
               invoke self "openFile"
           end-if

           move objSize to objectSize
           set address of recordBuffer to recordBufferPtr
           set objectkey to objhandle
           set objectRecordPtr to objAddress
           set fcd-Record-Address to recordBufferPtr
           set aPtr to recordBufferPtr
           move fhmaxRecordLength to fcd-current-rec-len
           move fhStartEqual to extfh-op-code
           call "EXTFH" using afhfunction, afcd
           perform until objectSize = 0
               if objectSize < maxRecordBufferLength
                   move objectSize to moveLength
                   move 0 to objectSize
               else
                   subtract maxRecordBufferLength from objectSize
                   move maxRecordBufferLength to moveLength
               end-if
               move moveLength to fcd-current-rec-len
               add length of objHandle to fcd-current-rec-len
               move fhread to extfh-op-code
               call "EXTFH" using afhfunction, afcd
               set address of objectRecord to objectRecordPtr
               move recordBuffer(5:moveLength)
                       to objectRecord(1:moveLength)
               set objectRecordPtr up by moveLength
           end-perform
           exit method.
       end method "read".
      *>-----------------------------------------------------------------
      *> PRIVATE. Deletes record from the objstore
      *>-----------------------------------------------------------------

       method-id. "delete".
       working-storage section.
       01 aPtr usage pointer.
       01 aPtr1 usage pointer.

       linkage section.
       01 objdetails.
           03 objhandle    usage object reference.
           03 objsize      pic x(4) comp-5.
           03 objaddress   pointer.
       01 objectDeleted    usage object reference.

       procedure division using objDetails.
           if objectsFinalizedPtr = null
               call "CBL_ALLOC_MEM" using objectsFinalizedPtr
                             BY VALUE objectsFinalizedBufferSize
                                      memAllocFlags
           end-if
           set aPtr to objectsFinalizedPtr
           set aPtr up by objectsFinalizedHeapTop
           set address of objectDeleted to aPtr
           set objectDeleted to objHandle
           add length of objectDeleted to objectsFinalizedHeapTop
           exit method.
       end method "delete".

      *>----------------------------------------------------------------
      *> PRIVATE. Called by the OOPS runtime when it can delete all the
      *> finalized objects from the persistent store.
      *>---------------------------------------------------------------
       method-id. "removeFinalizedObjects".
       working-storage section.
       01 aPtr  usage pointer.
       01 aPtr2 usage pointer.
       linkage section.
       01 objectDeleted usage object reference.
       procedure division.
           if objectsFinalizedPtr not = null
               if fcd-filename-address = null
                   invoke self "openFile"
               end-if
               set aPtr to objectsFinalizedPtr
               set aPtr2 to objectsFinalizedPtr
               set aPtr2 up by objectsFinalizedHeapTop
               move fhdelete to extfh-op-code
               perform until aPtr = aPtr2
                   set fcd-record-address to aPtr
                   call "EXTFH" using afhfunction, afcd
                   set aPtr up by length of objectDeleted
               end-perform
           end-if
           exit method.
       end method "removeFinalizedObjects".
      *>-----------------------------------------------------------------
      *> PRIVATE. Close the persistent store.
      *>-----------------------------------------------------------------

       method-id. "atEndOfSession".
       procedure division.
           move fhclose to extfh-op-code
           call "EXTFH" using afhfunction, afcd
           set fcd-filename-address to null
           exit method.
       end method "atEndOfSession".

      *>-----------------------------------------------------------------
      *> Return 1 if this is the first session otherwise return 0
      *>-----------------------------------------------------------------

       method-id. "isFirstSession".
       linkage section.
       01 lnkStatus         pic x comp-5.
       procedure division returning lnkStatus.
           move sessionStatus to lnkStatus
           exit method.
       end method "isFirstSession".

      *>-----------------------------------------------------------------
      *> PRIVATE. Open the object store.
      *>-----------------------------------------------------------------

       method-id. "openFile".
       working-storage section.
       procedure division.
               move fhmaxRecordlength to maxRecordBufferLength
               call "CBL_ALLOC_MEM" using recordBufferPtr
                                      by value maxRecordBufferLength
                                               memAllocFlags
               subtract objectKeyLength from maxRecordBufferLength
               move low-values to afcd,thekeydefinitionarea
               move fhindexed to fcd-organization
               move 128 to fcd-open-mode
               move fhrandomaccess to fcd-access-mode
               move maxfilenamelength to fcd-name-length
               move fhautomaticlocking to fcd-lock-mode
               move fhotherflags to fcd-other-flags
               move fhansi85 to fcd-status-type
               move fhdefaultfileformat to fcd-file-format
               move fhmaxrecordlength to fcd-max-rec-length
               move fhminrecordlength to fcd-min-rec-length
               move fhvariable to fcd-recording-mode
               move fhprimarykeyidentifier to fcd-key-id
               move objectReferenceSize to fcd-key-length
               move objectReferenceSize to offset-to-component
               subtract 1 from offset-to-component
               set fcd-filename-address
                   to address of anobjstorefilename
               set fcd-key-def-address
                   to address of thekeydefinitionarea

               move 30 to length-of-key-def-area
               move 1 to number-of-keys

               move 1 to component-count
               move objectReferenceSize to component-length
               move 30 to offset-to-component
               move fhprimekeydef to key-flags
               call "CBL_OR" using  fhDuplicatesAllowed
                                     key-flags
                                     by value length of key-flags
               move 0 to offset-to-component-def
               move objectReferenceSize to component-length
               move 1 to fcd-data-compress
               move fhopenio to extfh-op-code
               call "EXTFH" using afhfunction, afcd
               if not noobjstorefileerror
                   string anobjstorefilename delimited by space
                           "," delimited by size
                      into anobjstorefilename
                   if fcd-status-key-1 not = '9'
                       move fcd-status-key-2 to display-status-key
                   else
                       move fcd-binary to display-status-key
                   end-if
                   string anobjstorefilename delimited by space
                              fcd-status-key-1 delimited by size
                              "/" delimited by size
                              display-status-key delimited by size
                       into anobjstorefilename
                   display anobjstorefilename
                   move 31 to persistentstoreerror
                   invoke self "raiseexception"
                               using persistentstoreerror
               end-if
               exit method.
               end method "openFile".


      *>----------------------------------------------------------------
      *> PRIVATE. Called when at the start of the next session
      *>----------------------------------------------------------------
       method-id. "atStartOfNextSession".
       procedure division.
           exit method.
       end method "atStartOfNextsession".
      *>----------------------------------------------------------------
      *> PRIVATE. Called by the OOPS runtime when everything is ready to
      *> be executed.
      *>----------------------------------------------------------------

       method-id. "readyforapplicationstart".
       procedure division.
           invoke self "isDBCSEnvironment"
                       returning DBCSEnvironmentStatus
           add 1 to DBCSEnvironmentStatus
           exit method.
       end method "readyforapplicationstart".

       Object.
       object-storage section.
       end object.
       end class persistencemanager.
