      *>----------------------------------------------------------------
      *> This is a specialization of the association class which maps
      *> pic x(32) items to object references.
      *>
      *> Copyright (C) 1991,1996 Micro Focus Ltd.
      *>
      *>----------------------------------------------------------------
      $set mfoo

       Class-id. PicXToObject
              data is protected
              inherits from Association
              with data.

       Object section.

       Class-control.
           Association  is class "associtn"
           PicXToObject is class "picxtoob"
           CobolPicX32  is class "picx32"
           .
       object-storage section.

       procedure division.
           invoke self "initializeclass".
           exit program.

      *>----------------------------------------------------------------
      *> PRIVATE. initialize class data
      *>----------------------------------------------------------------
       method-id. "initializeclass".
       procedure division.
           invoke super "initializeclass"
           set keytemplate to CobolPicX32
           set datatemplate to null
           move 32 to keysize
           move objectReferenceSize to datasize
                                       storagerequirements
           add 32 to storagerequirements
           exit method.
       end method "initializeclass".

       object.
      *------------------------------------------------------------
      * Insert your object instance data declarations here
      *------------------------------------------------------------
       object-storage section.
       end object.
       end class PicXToObject.
